<template>
    <div class="users-filter">
        <base-filter
            v-model="filterData"
            :params="filterParams"
            :pickerOptions="pickerOptions"
            @apply="initFilter"
            @reset="resetFilter"
        >
            <download-csv-btn slot="btns-after" :filter="filterData" list-type="users"/>
        </base-filter>
    </div>
</template>

<script>
import { usersFilterSettings, defaultUsersFilter } from '@/constants/ui/filters';
import { mapState } from 'vuex';
import filterMixin from '@/mixins/filterMixin';
import BaseFilter from './baseFilter';
import DownloadCsvBtn from '@/components/DownloadCsvBtn';

export default {
    name: 'usersFilter',
    components: {
        BaseFilter,
        DownloadCsvBtn,
    },
    mixins: [filterMixin],
    data() {
        return {
            filterSettings: usersFilterSettings,
            filterData: defaultUsersFilter,
        };
    },
    computed: {
        ...mapState({
            serverFilter: state => state.users.users_filter,
        }),
    },
    methods: {
        /** Apply new user filter params */
        initFilter() {
            this.initLoading(this.$store.dispatch('filterUsersList', this.filterData));
        },
        /** Reset current user filter params */
        resetFilter() {
            this.filterData = { ...defaultUsersFilter };
            this.$store.commit('clearUsersFilter');
        },
    },
};
</script>
